=== lib/CMakeLists.txt ===
add_subdirectory(jp2)
add_subdirectory(jp2_plugin)
