=== debian/changelog ===
libgrokj2k (9.7.5-1) unstable; urgency=medium

    * Maintenance bug fix release

 -- Aaron Boxer <boxerab@protonmail.com>  Sun, 10 Apr 2022 11:10:00 +0200

libgrokj2k (9.5.0-1) unstable; urgency=medium

    * Maintenance bug fix release
    * Fixes GCC 11 build failure (Closes: #984111)

 -- Aaron Boxer <boxerab@protonmail.com>  Wed, 20 Oct 2021 11:10:00 +0200

libgrokj2k (9.2.0-1) unstable; urgency=high

    * Majour release
    * Fixes CVE-2021-36089 (Closes: #990525)

 -- Aaron Boxer <boxerab@gmail.com>  Sat, 22 May 2021 11:10:00 +0200
